]> arthur.barton.de Git - bup.git/blobdiff - Makefile
Makefile: check $(shell) exit statuses
[bup.git] / Makefile
index 311663c774e1f008dce4884da0e6161e6928f19c..5ffa48037f87bbc32817ae800d8aad44a5edd140 100644 (file)
--- a/Makefile
+++ b/Makefile
@@ -1,8 +1,30 @@
-OS:=$(shell uname | sed 's/[-_].*//')
-CFLAGS := -Wall -O2 -Werror $(PYINCLUDE) $(CFLAGS)
+
+SHELL := bash
+pf := set -o pipefail
+
+define isok
+  && echo " ok" || echo " no"
+endef
+
+# If ok, strip trailing " ok" and return the output, otherwise, error
+define shout
+$(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
+endef
+
+sampledata_rev := $(shell t/configure-sampledata --revision $(isok))
+sampledata_rev := \
+  $(call shout,$(sampledata_rev),Could not parse sampledata revision)
+
+current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)
+
+os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
+os := $(call shout,$(os),Unable to determine OS)
+
+CFLAGS := -Wall -O2 -Werror -Wno-unknown-pragmas $(PYINCLUDE) $(CFLAGS)
+CFLAGS := -D_FILE_OFFSET_BITS=64 $(CFLAGS)
 SOEXT:=.so
 
-ifeq ($(OS),CYGWIN)
+ifeq ($(os),CYGWIN)
   SOEXT:=.dll
 endif
 
@@ -12,17 +34,31 @@ else
   test_tmp := $(CURDIR)/t/tmp
 endif
 
-default: all
+initial_setup := $(shell ./configure-version --update $(isok))
+initial_setup := $(call shout,$(initial_setup),Version configuration failed))
+
+bup_deps := bup lib/bup/_version.py lib/bup/_helpers$(SOEXT) cmds
+
+all: $(bup_deps) Documentation/all $(current_sampledata)
 
-all: bup Documentation/all
+bup:
+       ln -s main.py bup
+
+Documentation/all: $(bup_deps)
+
+$(current_sampledata):
        t/configure-sampledata --setup
 
-bup: lib/bup/_version.py lib/bup/_helpers$(SOEXT) cmds
+# This needs to be a delayed assignment
+PYTHON = $(shell cmd/bup-python -c 'import sys; print sys.executable')
 
-Documentation/all: bup
+define install-python-bin
+  set -e; \
+  sed -e '1 s|.*|#!$(PYTHON)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
+  chmod 0755 $2;
+endef
 
 INSTALL=install
-PYTHON=python
 PREFIX=/usr
 MANDIR=$(DESTDIR)$(PREFIX)/share/man
 DOCDIR=$(DESTDIR)$(PREFIX)/share/doc/bup
@@ -40,10 +76,11 @@ install: all
          $(INSTALL) -m 0644 \
                Documentation/*.html \
                $(DOCDIR)
-       $(INSTALL) -pm 0755 bup $(BINDIR)
-       $(INSTALL) -pm 0755 \
-               cmd/bup-* \
-               $(LIBDIR)/cmd
+       $(call install-python-bin,bup,"$(BINDIR)/bup")
+       set -e; \
+       for cmd in $$(ls cmd/bup-* | grep -v cmd/bup-python); do \
+         $(call install-python-bin,"$$cmd","$(LIBDIR)/$$cmd") \
+       done
        $(INSTALL) -pm 0644 \
                lib/bup/*.py \
                $(LIBDIR)/bup
@@ -74,51 +111,70 @@ lib/bup/_helpers$(SOEXT): \
        LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(PYTHON) csetup.py build
        cp lib/bup/build/*/_helpers$(SOEXT) lib/bup/
 
-.PHONY: lib/bup/_version.py
 lib/bup/_version.py:
-       rm -f $@ $@.new
-       ./format-subst.pl $@.pre >$@.new
-       mv $@.new $@
-
-runtests: all runtests-python runtests-cmdline
-
-runtests-python: all
-       test -e t/tmp || mkdir t/tmp
-       TMPDIR="$(test_tmp)" $(PYTHON) wvtest.py t/t*.py lib/*/t/t*.py
-
-runtests-cmdline: all
-       test -e t/tmp || mkdir t/tmp
-       TMPDIR="$(test_tmp)" t/test-drecurse.sh
-       TMPDIR="$(test_tmp)" t/test-cat-file.sh
-       TMPDIR="$(test_tmp)" t/test-compression.sh
-       TMPDIR="$(test_tmp)" t/test-fsck.sh
-       TMPDIR="$(test_tmp)" t/test-index-clear.sh
-       TMPDIR="$(test_tmp)" t/test-index-check-device.sh
-       TMPDIR="$(test_tmp)" t/test-ls.sh
-       TMPDIR="$(test_tmp)" t/test-meta.sh
-       TMPDIR="$(test_tmp)" t/test-on.sh
-       TMPDIR="$(test_tmp)" t/test-restore-map-owner.sh
-       TMPDIR="$(test_tmp)" t/test-restore-single-file.sh
-       TMPDIR="$(test_tmp)" t/test-rm-between-index-and-save.sh
-       TMPDIR="$(test_tmp)" t/test-command-without-init-fails.sh
-       TMPDIR="$(test_tmp)" t/test-redundant-saves.sh
-       TMPDIR="$(test_tmp)" t/test-save-restore-excludes.sh
-       TMPDIR="$(test_tmp)" t/test-save-strip-graft.sh
-       TMPDIR="$(test_tmp)" t/test-import-rdiff-backup.sh
-       TMPDIR="$(test_tmp)" t/test-xdev.sh
-       TMPDIR="$(test_tmp)" t/test.sh
+       @echo "Something has gone wrong; $@ should already exist."
+       @echo 'Check "./configure-version --update"'
+       @false
+
+t/tmp:
+       mkdir t/tmp
+
+runtests: runtests-python runtests-cmdline
+
+runtests-python: all t/tmp
+       $(pf); TMPDIR="$(test_tmp)" \
+         $(PYTHON) wvtest.py t/t*.py lib/*/t/t*.py 2>&1 \
+           | tee -a t/tmp/test-log/$$$$.log
+
+cmdline_tests := \
+  t/test-index.sh \
+  t/test-split-join.sh \
+  t/test-fuse.sh \
+  t/test-drecurse.sh \
+  t/test-cat-file.sh \
+  t/test-compression.sh \
+  t/test-fsck.sh \
+  t/test-index-clear.sh \
+  t/test-index-check-device.sh \
+  t/test-ls.sh \
+  t/test-tz.sh \
+  t/test-meta.sh \
+  t/test-on.sh \
+  t/test-restore-map-owner.sh \
+  t/test-restore-single-file.sh \
+  t/test-rm-between-index-and-save.sh \
+  t/test-sparse-files.sh \
+  t/test-command-without-init-fails.sh \
+  t/test-redundant-saves.sh \
+  t/test-save-creates-no-unrefs.sh \
+  t/test-save-restore-excludes.sh \
+  t/test-save-strip-graft.sh \
+  t/test-import-duplicity.sh \
+  t/test-import-rdiff-backup.sh \
+  t/test-xdev.sh \
+  t/test.sh
+
+# For parallel runs.
+tmp-target-run-test%: all t/tmp
+       $(pf); TMPDIR="$(test_tmp)" \
+         t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log
+
+runtests-cmdline: $(subst t/test,tmp-target-run-test,$(cmdline_tests))
 
 stupid:
        PATH=/bin:/usr/bin $(MAKE) test
 
 test: all
-       ./wvtestrun $(MAKE) PYTHON=$(PYTHON) runtests
+       if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
+       mkdir -p t/tmp/test-log
+       ./wvtest watch --no-counts \
+         $(MAKE) PYTHON=$(PYTHON) runtests-python runtests-cmdline
+       ./wvtest report t/tmp/test-log/*.log
 
 check: test
 
-bup: main.py
-       rm -f $@
-       ln -s $< $@
+cmd/python-cmd.sh: config/configure config/configure.inc
+       ./configure
 
 cmds: \
     $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
@@ -128,14 +184,6 @@ cmd/bup-%: cmd/%-cmd.py
        rm -f $@
        ln -s $*-cmd.py $@
 
-%: %.py
-       rm -f $@
-       ln -s $< $@
-
-bup-%: cmd-%.sh
-       rm -f $@
-       ln -s $< $@
-
 cmd/bup-%: cmd/%-cmd.sh
        rm -f $@
        ln -s $*-cmd.sh $@
@@ -145,17 +193,18 @@ cmd/bup-%: cmd/%-cmd.sh
 export-docs: Documentation/all
        git update-ref refs/heads/man origin/man '' 2>/dev/null || true
        git update-ref refs/heads/html origin/html '' 2>/dev/null || true
+       set -eo pipefail; \
        GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
        rm -f $${GIT_INDEX_FILE} && \
        git add -f Documentation/*.1 && \
        git update-ref refs/heads/man \
-               $$(echo "Autogenerated man pages for $$(git describe)" \
+               $$(echo "Autogenerated man pages for $$(git describe --always)" \
                    | git commit-tree $$(git write-tree --prefix=Documentation) \
                                -p refs/heads/man) && \
        rm -f $${GIT_INDEX_FILE} && \
        git add -f Documentation/*.html && \
        git update-ref refs/heads/html \
-               $$(echo "Autogenerated html pages for $$(git describe)" \
+               $$(echo "Autogenerated html pages for $$(git describe --always)" \
                    | git commit-tree $$(git write-tree --prefix=Documentation) \
                                -p refs/heads/html)
 
@@ -166,25 +215,24 @@ push-docs: export-docs
 # import pregenerated doc files from origin/man and origin/html, in case you
 # don't have pandoc but still want to be able to install the docs.
 import-docs: Documentation/clean
-       git archive origin/html | (cd Documentation; tar -xvf -)
-       git archive origin/man | (cd Documentation; tar -xvf -)
+       $(pf); git archive origin/html | (cd Documentation && tar -xvf -)
+       $(pf); git archive origin/man | (cd Documentation && tar -xvf -)
 
 clean: Documentation/clean config/clean
        rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
                .*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
                *.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
-               bup bup-* cmd/bup-* lib/bup/_version.py randomgen memtest \
+               bup bup-* cmd/bup-* \
+               cmd/python-cmd.sh \
+               randomgen memtest \
                testfs.img lib/bup/t/testfs.img
        if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
        if test -e t/mnt; then rm -r t/mnt; fi
        if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
         # FIXME: migrate these to t/mnt/
-       if test -e bupmeta.tmp/testfs; \
-         then umount bupmeta.tmp/testfs || true; fi
        if test -e lib/bup/t/testfs; \
          then umount lib/bup/t/testfs || true; fi
-       if test -e bupmeta.tmp/testfs-limited; \
-         then umount bupmeta.tmp/testfs-limited || true; fi
        rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
        if test -e t/tmp; then t/force-delete t/tmp; fi
+       ./configure-version --clean
        t/configure-sampledata --clean